<?php

/************************************************************************/
/* ACEMail 0.9.4 for PhpNuke 6.5                                        */
/* ===========================================                          */
/* Copyright (c) 2003 by Eduin Yesid Carrillo(webmaster@scoutsace.org)  */
/* http://scoutsace.org                                                 */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

function MailBoxStats ($mbox) {
  
  if(!$mbox) {
    $stats = false;
  } else {
    $status = @imap_mailboxmsginfo($mbox);
    
    if (!$status) {
      $stats = false;
    } else {
      $stats = array (
      "message" => $status->Nmsgs,
      "recent" => $status->Recent,
      "unseen" => $status->Unread,
      "size" => $status->Size
      );      
    }
  }   

  return $stats; 
}


function DeleteMail ($mbox,$msgid) {

  if(!$mbox) { return imap_last_error(); }
  else {
    if(is_array($msgid)) {
  	  foreach($msgid as $mid) {
  	    @imap_delete ($mbox, $mid);
  	  }
    } else {
  	  @imap_delete ($mbox, $msgid);
    }
    @imap_expunge ($mbox);
  }
  
}


function OpenSession ($server, $port, $account_name, $account_password) {
  
  $mbox = @imap_open( "{".$server."/pop3:".$port."}INBOX", $account_name, $account_password );
  if(!$mbox ) {
    return false;
  } else {
    return $mbox;
  }
}

function CloseSession ( $mbox ) {
  @imap_close ( $mbox ); 
}

function MailOverview($mbox, $range) {

  $overview = @imap_fetch_overview($mbox,$range,0);
   
  if(is_array($overview)) {
    reset($overview);

    $messages = array ();
    
    while( list($key,$val) = each($overview)) {

      //Msgno
      $msgno = $val->msgno;

      //Date
      $date =  substr ($val->date , 5, 6);

      //Subject
      $su = @imap_mime_header_decode($val->subject);
      unset($subject);
      for($i=0; $i < count($su); $i++) {
        $subject .= $su[$i]->text;
      }

      //Sender
      $fr = trim(ereg_replace( "<[^<]*>", "", $val->from));
      $fr = @imap_mime_header_decode($fr);
      unset($from);
      for($i=0; $i < count($fr); $i++) {
        $from .= $fr[$i]->text;
      }

      //Size
      $si = $val->size;
      ($si < 1024) ? $size = $si."bytes" : $size = round($si/1024)."k";
      
      
      //New
      ($val->seen == 0 || $val->recent == 1) ? $new = true : $new = false;
      
      //Store values
      array_push($messages, array(
                              "msgno"=>$msgno,
                              "date"=>$date,
                              "subject"=>$subject,
                              "from"=>$from,
                              "size"=>$size,
                              "new"=>$new
                              ));
      
    }
  } else {
    $messages = false;
  }

  return $messages;

}

function MsgDate ($headers) {
  if(!empty( $headers->udate ) ) {  
    $date = strftime("%a, %d %b %Y %H:%M:%S", $headers->udate );
  }
  return $date;
}


function MsgSubject ($headers) {
  
  if(!empty( $headers->subject ) ) {  
    $sub = $headers->subject;
    $sub = @imap_mime_header_decode($sub);
    unset($subject);
    for($i=0; $i<count($sub); $i++) {
      $subject .= $sub[$i]->text;
    }  
  }
  return $subject;
}


function MsgFrom ( $headers ) {
  
  if(!empty( $headers->from ) ) {  
     unset ($person); unset($email);
     $from = $headers->from[ 0 ];
     while ( list( $key, $val ) = each( $from ) ) {
        $val1 = @imap_mime_header_decode($val);
        $val = "";
        for($i=0;$i<count($val1);$i++) {
          $val .= $val1[$i]->text;
        }         
        if( $key == "personal" ) { $person .= $val ; }
        if( $key == "mailbox" )  { $email .= $val; }
        if( $key == "host" )     { $email .= "@" . $val; }
     }
    
    if($person != "") 
      $from = "\"". $person . "\" &lt;" . $email . "&gt;"; 
    else 
      $from = $email; 
   
    return $from;
  }
}

function MsgPersons ( $headarray ) {
    
  foreach($headarray as $item) {  
    unset($person); unset($email);
    
    while (list( $key, $val) = each( $item ) )  {
      $val1 = @imap_mime_header_decode($val);
      $val = "";
      
      for($i = 0; $i<count($val1); $i++) {
        $val .= $val1[$i]->text;
      }                 
      
      if( $key == "personal" ) { $person .= $val; }
      if( $key == "mailbox" )  { $email .= $val; }
      if( $key == "host" )     { $email .= "@" . $val; }
    }
    if($person != "")
      $persons .= "\"". $person . "\" &lt;" . $email . "&gt;"; 
    else 
      $persons .= $email; 
    
    $j++;
    if (sizeof($headarray) != $j) 
      $persons .= ", ";
  }

  return $persons;
}


function MailHeaders($mbox, $pop3id) {
  
  $headers =   @imap_header( $mbox, $pop3id );
  
  if (is_array($headers->from))
    $from = MsgPersons ( $headers->from );

  if (is_array($headers->to))
    $to = MsgPersons ( $headers->to );

  if (is_array($headers->cc))
    $cc = MsgPersons ( $headers->cc );

  if (is_array($headers->bcc))
    $bcc = MsgPersons ( $headers->bcc );

  if (is_array($headers->reply_to))
    $replyto = MsgPersons ( $headers->reply_to );

  $subject = MsgSubject ( $headers );
    
  $date = MsgDate ( $headers );
  
  return array($from, $to, $cc, $bcc, $replyto, $subject, $date);
}

function GetPart( $stream, $msg_number, $mime_type, $structure = false, $part_number = false ) {
//Based on GetPart function
//SiteMail v. 1.2
//Copyright  2002 by: Maty Scripts (webmaster@mat.allfreetemplates.com)           */
//http://mat.allfreetemplates.com 

   if( !$structure ) {
      $structure = @imap_fetchstructure($stream, $msg_number);
   }
   
   if($structure) {
      if( $mime_type == RealMimeType($structure) ) {
         if(!$part_number ) {
            $part_number = "1";
         }
         
         $text = @imap_fetchbody($stream, $msg_number, $part_number);
         if( $structure->encoding == 3) {
            return @imap_base64($text);
         }
         else if( $structure->encoding == 4) {
            return @imap_qprint($text);
         } else {
            return $text;
         }
      }
      
      /* multipart */
      if( $structure->type == 1 )  {
         while(list($index, $sub_structure)=each($structure->parts)) {
            if( $part_number ) {
               $prefix = $part_number . '.';
            }
            $data = GetPart( $stream, $msg_number, $mime_type, $sub_structure, $prefix . ($index + 1));
            if( $data ) {
               return $data;
            }
         }
      }
   
   }
   return false;
}

function RealMimeType( &$structure ) {
//Based on GetMimeType function
//SiteMail v. 1.2
//Copyright  2002 by: Maty Scripts (webmaster@mat.allfreetemplates.com)           */
//http://mat.allfreetemplates.com 
  
   if($structure->subtype) {
      return PrimaryMimeType ( $structure->type ) .
             '/' .
             $structure->subtype;
   }
   return "TEXT/PLAIN";
}

function FormatText ( $text ,$wrap=80) {
  
  //Replace Hiperlinks
  $text = preg_replace(
        "!(".
        "(([a-z]{3,5}://)|(www.|ftp.))".
        "[^/^\s]+".
        "(:[0-9]+)?".
        "(/([^\s]*[^\s,.])?)?".
        "(\?([^\s]*[^\s,.])?)".
        "?)!i", 
        "<a class=mess href=\"\\1\">\\1</a>", $text);

  //Email Links
  $text = eregi_replace("([_\.0-9a-z-]+)@([0-9a-z][0-9a-z-]+)\.([a-z]{2,6})(\.{0,1}[a-z]+)", 
         "<a class=mess href=\"mailto:\\1@\\2.\\3\\4\">\\1@\\2.\\3\\4</a>",$text ); 
  
  //Wrap
  $text = wordwrap ( $text, $wrap );
  
  //Cut large lines
  $message = split( "\n", $text);
  reset ( $message );
  while (list ($clave, $val) = each ( $message )) {
    $val2 = strip_tags ($val);
    if ( !ereg (" ", $val2) and strlen ( $val2) > $wrap ) {
      $message[ $clave ] = chunk_split ( $val, $wrap );
    }
  }
  
  return implode ("\n", $message);    
  
}

// Debug function.. always handy until it's 100% completed..
// (c) paradise@ml75.com Paradise (www.ml75.nl)
function doDebug($msg) {
  
  global $debug, $debug_depth, $dispos;
  
  if($debug) {
    for($y = 0; $y < $debug_depth; $y++) 
      echo("&nbsp;&nbsp;&nbsp;&nbsp;");
    if($dispos == 0) 
      echo($msg."<br/>"); 
    else 
      echo("<i>".$msg."</i><br/>");
  }
}

// (c) paradise@ml75.com Paradise (www.ml75.nl)
function Check_Part($part,$id) {
  global $attachments, $debug, $debug_depth, $dispos;
  
  $ans = sizeof($attachments);
  
  doDebug("+Checking part $id");
  $debug_depth++;
  doDebug("Parttype=".$part->type ."/". PrimaryMimeType($part->type) ."/". $part->subtype);

  if($part->ifdisposition){ 
    $dispos++; doDebug("<b>Disposition</b>");
  }
  
  if($part->ifdescription){
    doDebug("<b>Description=".$part->description."</b>");
  }

  switch($part->type) {
    case 1:
    if((strtolower($part->subtype)     == "mixed") 
       or (strtolower($part->subtype)  == "alternative")
       or (strtolower($part->subtype)  == "related")) 
    break;

  default: 
    $an = sizeof($attachments);
      
    if($part->ifdparameters) {
        
      $dpara = $part->dparameters;
      for ($v=0;$v<sizeof($dpara);$v++) {
        if (eregi("filename", $dpara[$v]->attribute)) 
          $fname = $dpara[$v]->value;
      }
    }
      
    if($part->ifparameters) {
      if(empty($fname)) {
          
        $para = $part->parameters;
        for ($v=0;$v<sizeof($para);$v++) {
          if (eregi("name", $para[$v]->attribute)) 
            $fname = $para[$v]->value;
        }
      }
    }
      
    if(empty($fname))
      $fname = "Unknown";

    $realmime = RealMimeType ( $part );
    
    $attachments[$an]->id = ($an+1);
    $attachments[$an]->part = $id;
    $attachments[$an]->filename = $fname;
    $attachments[$an]->type=$part->type;
    $attachments[$an]->subtype=$part->subtype;
    $attachments[$an]->dispos=$dispos;
    $attachments[$an]->size=$part->bytes;
    $attachments[$an]->encoding=$part->encoding;
    $attachments[$an]->description=$part->description;
    $attachments[$an]->realmime=$realmime;
    
    doDebug("Filename=".$attachments[$an]->filename); 
    doDebug("Filesize=".$attachments[$an]->size); 
    break;
  }

  for($x = 0; $x < count($part->parts); $x++) {
    Check_Part($part->parts[$x], $id.".".($x+1));
  }
  
  doDebug("Dit deel had iets nuttigs.");
    
  if($part->ifdisposition) 
    $dispos--;

  $debug_depth--;
  doDebug("-End of part $id");
}

// (c) paradise@ml75.com Paradise (www.ml75.nl)
function PrimaryMimeType ($type) {
  $primary_mime_type = array( 
     "TEXT",
     "MULTIPART",
     "MESSAGE",
     "APPLICATION",
     "AUDIO",
     "IMAGE",
     "VIDEO",
     "OTHER"
     );
  return $primary_mime_type[ ( int ) $type ];
}

// (c) paradise@ml75.com Paradise (www.ml75.nl)
function Decode_Mail($mbox, $msg) {
  
  global $attachments, $debug, $debug_depth;
  global $body;
  
  doDebug("+Decoding message $msg"); 
  $debug_depth++;
  
  $obj = @imap_fetchstructure($mbox, $msg, FT_UID);
  $moet_werken=true;
  $id=1;
  
  while($moet_werken) {
    Check_Part($obj, $id);
    $moet_werken=false;
  }
  $debug_depth--;
  doDebug("-End of message $msg");
  
}


// get the body of a part of a message according to the
// string in $part
// ulrich@kaldamar.de
function mail_fetchpart($mbox, $msgNo, $part) {
    $parts = mail_fetchparts($mbox, $msgNo);
    
    $partNos = explode(".", $part);
    
    $currentPart = $parts;
    while(list ($key, $val) = each($partNos)) {
        $currentPart = $currentPart[$val];
    }
    
    if ($currentPart != "") return $currentPart;
      else return false;
}

// splits a message given in the body if it is
// a mulitpart mime message and returns the parts,
// if no parts are found, returns false
// ulrich@kaldamar.de
function mail_mimesplit($header, $body) {
    $parts = array();
    
    $PN_EREG_BOUNDARY = "Content-Type:(.*)boundary=\"([^\"]+)\"";

    if (eregi ($PN_EREG_BOUNDARY, $header, $regs)) {
        $boundary = $regs[2];

        $delimiterReg = "([^\r\n]*)$boundary([^\r\n]*)";
        if (eregi ($delimiterReg, $body, $results)) {
            $delimiter = $results[0];
            $parts = explode($delimiter, $body);
            $parts = array_slice ($parts, 1, -1);
        }
        
        return $parts;
    } else {
        return false;
    }    
    
    
}

// returns an array with all parts that are
// subparts of the given part
// if no subparts are found, return the body of 
// the current part
// ulrich@kaldamar.de
function mail_mimesub($part) {
    $i = 1;
    $headDelimiter = "\r\n\r\n";
    $delLength = strlen($headDelimiter);

    // get head & body of the current part
    $endOfHead = strpos( $part, $headDelimiter);
    $head = substr($part, 0, $endOfHead);
    $body = substr($part, $endOfHead + $delLength, strlen($part));
    
    // check whether it is a message according to rfc822
    if (stristr($head, "Content-Type: message/rfc822")) {
        $part = substr($part, $endOfHead + $delLength, strlen($part));
        $returnParts[1] = mail_mimesub($part);
        return $returnParts;
    // if no message, get subparts and call function recursively
    } elseif ($subParts = mail_mimesplit($head, $body)) {
        // got more subparts
        while (list ($key, $val) = each($subParts)) {
            $returnParts[$i] = mail_mimesub($val);
            $i++;
        }            
        return $returnParts;
    } else {
        return $body;
    }
}

// get an array with the bodies all parts of an email
// the structure of the array corresponds to the 
// structure that is available with imap_fetchstructure
// ulrich@kaldamar.de
function mail_fetchparts($mbox, $msgNo) {
    $parts = array();
    $header = imap_fetchheader($mbox,$msgNo);
    $body = imap_body($mbox,$msgNo, FT_INTERNAL);
    
    $i = 1;
    
    if ($newParts = mail_mimesplit($header, $body)) {
        while (list ($key, $val) = each($newParts)) {
            $parts[$i] = mail_mimesub($val);
            $i++;                
        }
    } else {
        $parts[$i] = $body;
    }
    return $parts;
    
}
?>